
# Before start

0. Please install `mean-average-precision` and `xmltodict` python packages. 

    To install required packages using following command:

    ```bash
    pip install -r catalyst/examples/detection/requirements.txt
    ```

1. Create or convert existing one training and validation datasets to [COCO format](https://cocodataset.org/#format-data) - you need to have `.json` files with annotations.

In this example will be used dataset from [Kaggle - Fruit Detection](https://www.kaggle.com/andrewmvd/fruit-detection).

To convert it to COCO you need to use `to_coco.py` script. This script requires additional package - [`xmltodict`](https://pypi.org/project/xmltodict/).


Usage is simple:

```bash
python3 to_coco.py <images directory> <annotations directory> <output json file>
```


## Single Shot Detector (SSD)

For training SSD it is required for the dataset to return bounding box tensor with shapes `[num anchors, 4]` and labels tensor with shapes `[num anchors]`, `num anchors` is a fixed number of predictions generated by a model.

Each bounding box should be in a format `[x_center, y_center, width, height]`. Usually, there are fewer objects on an image than `num anchors` returned by a model, to handle this your model should have an additional class for `background` and bounding boxes to ignore (or empty bounding boxes) should be marked with that class.


```bash
catalyst-dl run \
    --config catalyst/examples/detection/ssd-config.yaml \
    --expdir catalyst/examples/detection \
    --logdir ssd-detection-logs
    --verbose
```


## Training CenterNet

For training CenterNet it is required for the dataset to return heatmap tensor with object centers (expected shape is `[num classes, heatmap height, heatmap width]`) and tensor for Width-Height regression (expected shape is `[2, heatmap height, heatmap width]`).

```bash
catalyst-dl run \
    --config catalyst/examples/detection/centernet-config.yaml \
    --expdir catalyst/examples/detection \
    --logdir centernet-detection-logs
    --verbose
```
